* ErRor - textmode intro
* coded by pr0be
* 25/02/2004
*
* atom.asm - "atom" effect

ax2	equ $b0
ay2	equ $b1
delx	equ $b2
dely	equ $b3
count2	equ $b4
cc	equ $5e
cc2	equ $5f

	org $8550

* setup
atom	ldx #<colpal2
	ldy #>colpal2
	jsr setpal
	lda #$e6
	sta cc
	lda #$03
	sta cc2

* main
doatom	jsr clrscr

	lda #$12
	sta count2

loop	ldy count2
	lda pa,y
	clc
	adc pi,y
	sta pa,y
	tax
	lda pl,y
	ldy sintab,x
	jsr fmul
	clc
	adc #20
	sta tmp
	ldy count2
	lda pl,y
	ldx pa,y
	ldy costab,x
	jsr fmul
	clc
	adc #12
	sta tmp2
	lda #39
	sec
	sbc tmp
	sta ax2
	lda #23
	sec
	sbc tmp2
	sta ay2
	ldy tmp
	ldx tmp2
	jsr drawln

	dec count2
	bpl loop

	jsr flpscr

	dec cc
	bne doatom
	dec cc+1
	bne doatom
	jsr clrscr
	jsr flpscr
	jmp gouraud

* drawln
drawln	cpy ax2
	bcc cldx1
	lda #$88
	sta bp1
	sta bp4
	tya
	sbc ax2
	jmp cldx2
cldx1	lda #$c8
	sta bp1
	sta bp4
	sty tmp
	lda ax2
	sec
	sbc tmp
cldx2	sta delx

	cpx ay2
	bcc cldy1
	lda #$ca
	sta bp2
	sta bp3
	txa
	sbc ay2
	jmp cldy2
cldy1	lda #$e8
	sta bp2
	sta bp3
	stx tmp
	lda ay2
	sec
	sbc tmp
cldy2	sta dely

	txa
	clc
	adc screen
	sta $fb
	lda ($fa),y
	clc
	adc #$02
	cmp #$0d
	bcc _ln1
	ora #$80
	cmp #$90
	bcc _ln1
	lda #$90
_ln1	sta ($fa),y

	lda dely
	cmp delx
	bcs lnstepy

	lda #$00
	sec
	sbc delx
	clc

bp1	iny
	adc dely
	bcc stepx
bp2	inx
	sbc delx

stepx	pha
	txa
	clc
	adc screen
	sta $fb
	lda ($fa),y
	clc
	adc #$02
	cmp #$0d
	bcc _ln2
	ora #$80
	cmp #$90
	bcc _ln2
	lda #$90
_ln2	sta ($fa),y
	pla

	cpy ax2
	bne bp1
	rts

lnstepy	lda #$00
	sbc dely
	clc

bp3	inx
	adc delx
	bcc stepy
bp4	iny
	sbc dely

stepy	pha
	txa
	clc
	adc screen
	sta $fb
	lda ($fa),y
	clc
	adc #$02
	cmp #$0d
	bcc _ln3
	ora #$80
	cmp #$90
	bcc _ln3
	lda #$90
_ln3	sta ($fa),y
	pla

	cpx ay2
	bne bp3
	rts

colpal2	dta $f6,$fa,$f4,$ff

pl	dta $04,$04,$05,$05,$05,$04,$04,$04,$06,$07,$08,$07,$07,$08,$09,$08,$06,$05,$06
pa	dta $00,$44,$20,$60,$8c,$c8,$aa,$e6,$9b,$ed,$d2,$6e,$32,$4b,$90,$50,$63,$16,$c5
pi	dta $06,$04,$04,$06,$04,$06,$04,$06,$04,$03,$02,$05,$05,$04,$03,$04,$03,$04,$03
