* ErRor - textmode intro
* coded by pr0be
* 20/02/2004
*
* init.asm - initialize routine

tmp	equ $c0
tmp2	equ $c1
ext	equ $c2
screen	equ $c3

sqrtab	equ $4e00
coltab	equ $5028
costab	equ sintab+$40

iccmd	equ $0342
icbufa	equ $0344
icbufl	equ $0348
icax1	equ $034a
icax2	equ $034b
ciomain	equ $e456
exitvbl	equ 58466
setvblv	equ 58460

	org $8000

* flip screen
flpscr	lda screen
	cmp #$50
	bne flp
	ldx #<dl1
	ldy #>dl1
	lda #$68
	bne flp2
flp	ldx #<dl2
	ldy #>dl2
	lda #$50
flp2	sta screen
	lda 20
	cmp 20
	beq *-2		* poczekaj ramke na zmiane adresu obrazu
	stx $d402
	sty $d403	* a potem zmien...
	stx 560
	sty 561

	lda 764
	cmp #28
	beq _dos
	rts
_dos	lda #$ff
	sta 764
	sta $f5
	jsr RASTERMUSICTRACKER+9
	jsr setgr0
	jmp ($0a)

* clear buffer
clrscr	ldx #$00
	lda screen
	cmp #$50
	bne clear2

	lda #$00
clr1	sta $5000,x	* czysc 1 linie
	sta $5100,x	* 2 linie
	sta $5200,x	* 3 linie
	sta $5300,x
	sta $5400,x
	sta $5500,x
	sta $5600,x
	sta $5700,x
	sta $5800,x
	sta $5900,x
	sta $5a00,x
	sta $5b00,x
	sta $5c00,x
	sta $5d00,x
	sta $5e00,x
	sta $5f00,x
	sta $6000,x
	sta $6100,x
	sta $6200,x
	sta $6300,x
	sta $6400,x
	sta $6500,x
	sta $6600,x
	sta $6700,x	* 24 linie...
	inx
	cpx #40
	bne clr1
	rts

clear2	lda #$00
clr2	sta $6800,x	* czysc 1 linie
	sta $6900,x	* 2 linie
	sta $6a00,x	* 3 linie
	sta $6b00,x
	sta $6c00,x
	sta $6d00,x
	sta $6e00,x
	sta $6f00,x
	sta $7000,x
	sta $7100,x
	sta $7200,x
	sta $7300,x
	sta $7400,x
	sta $7500,x
	sta $7600,x
	sta $7700,x
	sta $7800,x
	sta $7900,x
	sta $7a00,x
	sta $7b00,x
	sta $7c00,x
	sta $7d00,x
	sta $7e00,x
	sta $7f00,x	* 24 linie...
	inx
	cpx #40
	bne clr2
	rts

* 16bit multiply A,EXT -> A*X
mult	sta tmp
	lda #$00
	sta ext
mult2	clc
	adc tmp
	bcc *+4
	inc ext
	dex
	bne mult2
	rts

* setup pallete
setpal	stx tmp
	sty tmp+1
	ldy #$03
_stpal	lda (tmp),y
	sta 708,y
	dey
	bpl _stpal
	rts

* fast multiply A*Y->A
fmul	sta $fc
	eor #$ff
	clc
	adc #$01
	sta $fe
	lda ($fc),y
	sec
	sbc ($fe),y
	rts

* init

* generate fast-antic4 mode
init	ldx #$00
	ldy #$50
genant	lda #$44
	sta dl1+3,x
	sta dl2+3,x
	inx
	lda #$00
	sta dl1+3,x
	sta dl2+3,x
	inx
	tya
	sta dl1+3,x
	clc
	adc #$18
	sta dl2+3,x
	inx
	iny
	cpy #$68
	bne genant

* generate color table
	ldx #$10
	ldy #$00
genct1	txa
	cpx #$0d
	bcc genct2
	adc #$7f
genct2	sta coltab,x
	sta coltab+16,y
	iny
	dex
	bpl genct1

* generate square table
	ldy #$00
	sty sqrtab
	sty sqrtab+256
gensqrt	iny
	tya
	tax
	jsr mult	* oblicz kwadrat
	ldx #$07
_gsqrt	lsr ext
	ror @
	dex
	bne _gsqrt	* div 128
	sta sqrtab,y
	sta sqrtab+256,y
	pha
	tya
	eor #$ff
	clc
	adc #$01
	tax		* X=256-Y
	pla
	sta sqrtab,x
	sta sqrtab+256,x
	cpy #128
	bne gensqrt

	lda #>sqrtab
	sta $fd
	sta $ff

* setup
	lda #$50
	sta screen	* ustaw adres obrazu
	lda #$00
	sta 712
	sta $fa		* wyczysc starszy bajt adresu pixela
	sta $f5

	lda #>chbase
	sta 756		* ustaw zestaw znakow

	ldx #<MSX
	ldy #>MSX
	lda #0
	jsr RASTERMUSICTRACKER

	ldy #0
	ldx #6
	lda #7
	jsr setvblv

	icl "fadetext.asm"
	icl "atom.asm"
	icl "gouraud.asm"
	icl "plasma.asm"

* VBL
	org $0600

	lda $f5
	bmi _ext
	jsr RASTERMUSICTRACKER+3
_ext	jmp exitvbl

* tables
	org $4800
chbase	ins "charset.dat"

	org $4900
dl1	dta $70,$70,$70
	org dl1+75
	dta $41,a(dl1)

dl2	dta $70,$70,$70
	org dl2+75
	dta $41,a(dl2)

	org $4a00
sintab	ins "sintab.dat"
	org $4c00
pcostab	ins "pcostab.dat"

	org $5128
font	ins "font.dat"

* RMT
MSX		equ $9600
STEREOMODE	equ 0

	icl "rmtplayr.a65"

	opt h-
	org MSX
	ins "msx.rmt"
	opt h+

*
	run init
