* ErRor - textmode intro
* coded by pr0be
* 20/02/2004
*
* plasma.asm - plasma+fadeout text

p1	equ $a0
p2	equ $a1
p3	equ $a2
p4	equ $a3
t1	equ $a4
t2	equ $a5
t3	equ $a6
t4	equ $a7
count	equ $a8
temp	equ $a9
temp2	equ $aa
temp3	equ $ab
lgdelay	equ $ad
txt1p	equ $b0
txt1_fv	equ $b2
txt1i	equ $b3
txt2p	equ $b6
txt2_fv	equ $b8
txt2i	equ $b9

coltab2	equ $4d00

* setup
	ldx #$00
	ldy #$00
flcl1	lda #$0f
	sta tmp
	lda coltab,x
flcl2	sta coltab2,y
	iny
	dec tmp
	bpl flcl2
	inx
	cpx #$10
	bne flcl1

	ldx #<colpal
	ldy #>colpal
	jsr setpal

	lda #<text1
	sta txt1p
	lda #>text1
	sta txt1p+1
	lda #<text2
	sta txt2p
	lda #>text2
	sta txt2p+1
	lda #$01
	sta txt1_fv
	lda #$00
	sta txt1i
	sta txt2i
	lda #$0a
	sta txt2_fv
	lda #$66
	sta lgdelay

* main
main	lda screen
	sta $fb

* do plasma
	lda p3
	sta t3		* t3=p3
	lda p4
	sta t4		* t4=p4

	lda #23
	sta count

loopi	inc t3		* t3=t3+1
	lda t4
	clc
	adc #$02
	sta t4		* t4=t4+2
	lda p1
	sta t1		* t1=p1
	lda p2
	sta t2		* t2=p2

	ldy #39
*
loopj	ldx t4
	lda pcostab,x	* cos(t4)
	ldx t2
	clc
	adc pcostab,x	* +cos(t2)
	ldx t1
	adc pcostab,x	* +cos(t1)
	ldx t3
	adc pcostab,x	* +cos(t3)
	tax

* plot pixel
	lda coltab2,x
	sta ($fa),y
*
	lda t1
	clc
	adc #$03
	sta t1		* t1=t1+3
	inc t2		* t2=t2+1

	dey
	bpl loopj

	inc $fb
	dec count
	bpl loopi

	inc p1		* p1=p1+1
	lda p2
	clc
	adc #$04
	sta p2		* p2=p2+4
	lda p3
	clc
	adc #$03
	sta p3		* p3=p3+3
	inc p4		* p4=p4+1

* fade text
	lda txt2i
	bpl *+5
	jmp atom

	lda txt1i
	bpl dofade

drawlg	lda screen
	clc
	adc #$05
	sta $fb
	ldx #$00
	ldy #$09
drwlogo	lda logo,x
	cmp #$ff
	beq _drw2
	sta ($fa),y
_drw2	inx
	beq _drwlg
	iny
	cpy #32
	bne drwlogo
	inc $fb
	ldy #$09
	jmp drwlogo
_drwlg	lda logo+255,x
	cmp #$ff
	beq _drw3
	sta ($fa),y
_drw3	inx
	iny
	cpy #32
	bne _drwlg
	dec lgdelay
	bne _drwe
	lda #$01
	sta txt1i
	sta txt1_fv
_drwe	jmp _flp

dofade	dec txt1_fv
	bne prntxt1
	lda txt1p
	clc
	adc txt1i
	bcc *+4
	inc txt1p+1
	sta txt1p
	ldy #$00
_ftl1	lda (txt1p),y
	sta txt1i,y
	iny
	cpy #$03
	bne _ftl1
	lda #$14
	sta txt1_fv
	jmp dofade2
prntxt1	lda txt1p
	sta $f8
	lda txt1p+1
	sta $f9
	ldy txt1i+1
	ldx txt1i+2
	lda txt1_fv
	jsr print
dofade2	dec txt2_fv
	bne prntxt2
	lda txt2p
	clc
	adc txt2i
	bcc *+4
	inc txt2p+1
	sta txt2p
	ldy #$00
_ftl2	lda (txt2p),y
	sta txt2i,y
	iny
	cpy #$03
	bne _ftl2
	lda #$14
	sta txt2_fv
	jmp _flp
prntxt2	lda txt2p
	sta $f8
	lda txt2p+1
	sta $f9
	ldy txt2i+1
	ldx txt2i+2
	lda txt2_fv
	jsr print
*

_flp	jsr flpscr
	jmp main

* print fade text (Y,X,str=($f8),fade=A)
print	sta temp3
	sty tmp2
	ldy #$03

_prt	lda ($f8),y
	bne _prt2
	rts
_prt2	sty temp
	stx temp2

* putchar (tmp2,X,chr=A)
	sta tmp
	asl @
	asl @
	clc
	adc tmp
	sta tmp		* tmp=A*5
	txa
	clc
	adc screen
	sta $fb

	ldx tmp
	lda #$04
	sta count

_pch	lda tmp2
	sta $fa
	ldy #$00
	lda font,x
	stx temp3+1
	sta tmp
	clc
	
	and #$80
	cmp #$80
	bne _pc1
	lda ($fa),y
	adc temp3
	cmp #$0d
	bcc _pcc1
	ora #$80
	cmp #$90
	bcc _pcc1
	lda #$90
_pcc1	sta ($fa),y

_pc1	iny
	lda tmp
	and #$40
	cmp #$40
	bne _pc2
	lda ($fa),y
	adc temp3
	cmp #$0d
	bcc _pcc2
	ora #$80
	cmp #$90
	bcc _pcc2
	lda #$90
_pcc2	sta ($fa),y

_pc2	iny
	lda tmp
	and #$20
	cmp #$20
	bne _pc3
	lda ($fa),y
	adc temp3
	cmp #$0d
	bcc _pcc3
	ora #$80
	cmp #$90
	bcc _pcc3
	lda #$90
_pcc3	sta ($fa),y

_pc3	iny
	lda tmp
	and #$10
	cmp #$10
	bne _pc4
	lda ($fa),y
	adc temp3
	cmp #$0d
	bcc _pcc4
	ora #$80
	cmp #$90
	bcc _pcc4
	lda #$90
_pcc4	sta ($fa),y

_pc4	ldx temp3+1
	inx
	inc $fb
	dec count
	bpl _pch

	lda #$00
	sta $fa		* zawsze czysc mlodszy bajt adresu pixela
*

	ldx temp2
	ldy temp
	lda tmp2
	clc
	adc #$04
	sta tmp2
	iny
	jmp _prt

*
colpal	dta $b8,$1c,$94,$0e

text1	dta 4,0,0,$00,8,16,9,$14,$08,$09,$13,$00
	dta 5,18,9,$01,$00
	dta 8,9,7,$0d,$0f,$04,$05,$00
	dta 10,4,6,$03,$01,$0c,$0c,$05,$04,$00
	dta $ff
	dta 11,5,4,$03,$12,$05,$01,$14,$05,$04,$00
	dta 8,6,8,$1b,$1c,$0f,$1d,$00
	dta 4,0,0,$00

text2	dta 4,0,0,$00,6,20,16,$09,$13,$00
	dta 8,5,4,$14,$05,$18,$14,$00
	dta 9,20,17,$09,$0e,$14,$12,$0f,$00
	dta 4,0,0,$00
	dta 7,12,9,$06,$0f,$12,$00
	dta 9,12,10,$03,$0f,$0d,$10,$0f,$00
	dta $ff

logo	ins "logo.dat"
