* ErRor - textmode intro
* coded by pr0be
* 28/02/2004
*
* rtplasm.asm - real time plasma

	org $8c90

* setup
rtplsm	ldx #$00
	ldy #$00
aflcl1	lda #$07
	sta tmp
	lda coltab,x
aflcl2	sta coltab2,y
	iny
	dec tmp
	bpl aflcl2
	inx
	cpx #$20
	bne aflcl1

	ldx #<colpal3
	ldy #>colpal3
	jsr setpal
	lda #$92
	sta 712

	lda #$ff
	sta cc
	lda #$01
	sta cc2

* main
pmain	lda screen
	sta $fb

* do plasma
	lda p3
	sta t3		* t3=p3
	lda p4
	sta t4		* t4=p4

	lda #23
	sta count

ploopi	dec t3		* t3=t3-1
	lda t4
	clc
	adc #$02
	sta t4		* t4=t4+2
	lda p1
	sta t1		* t1=p1
	lda p2
	sta t2		* t2=p2

	ldy #39
*
ploopj	ldx t4
	lda pcostab,x	* cos(t4)
	ldx t2
	clc
	adc pcostab,x	* +cos(t2)
	ldx t1
	adc pcostab,x	* +cos(t1)
	ldx t3
	adc pcostab,x	* +cos(t3)
	tax

* plot pixel
	lda coltab2,x
	sta ($fa),y
*
	lda t1
	clc
	adc #$03
	sta t1		* t1=t1+3
	inc t2		* t2=t2+1

	dey
	bpl ploopj

	inc $fb
	dec count
	bpl ploopi

	dec p1
	dec p1		* p1=p1-2
	lda p2
	clc
	adc #$04
	sta p2		* p2=p2+4
	lda p3
	sec
	sbc #$03
	sta p3		* p3=p3-3
	inc p4		* p4=p4+1

* rotate pallete
	lda coltab2
	sta tmp
	ldx #$08
_rotpal	lda coltab2,x
	sta coltab2-1,x
	sta coltab2-2,x
	sta coltab2-3,x
	sta coltab2-4,x
	sta coltab2-5,x
	sta coltab2-6,x
	sta coltab2-7,x
	sta coltab2-8,x
	txa
	clc
	adc #$08
	tax
	bne _rotpal
	lda tmp
	sta coltab2+$f8
	sta coltab2+$f9
	sta coltab2+$fa
	sta coltab2+$fb
	sta coltab2+$fc
	sta coltab2+$fd
	sta coltab2+$fe
	sta coltab2+$ff

	jsr flpscr

	dec cc
	bne _pmain
	dec cc+1
	bne _pmain
	jmp _pexit

_pmain	jmp pmain

_pexit	jsr setgr0

	lda 560
	sta $f6
	lda 561
	sta $f7
	ldy #$04
	lda ($f6),y
	sta $f8
	iny
	lda ($f6),y
	sta $f9
	ldy #$02
	lda #$00
	sta ($f8),y
	sta 710

	lda $f8
	clc
	adc #$f2
	bcc *+4
	inc $f9
	sta $f8

	ldy #$00
_drwlgg	lda telogo,y
	sta ($f8),y
	iny
	bne _drwlgg
	inc $f9

_drwlg2	lda telogo+$100,y
	sta ($f8),y
	iny
	cpy #104
	bne _drwlg2
_kkey	lda 764
	cmp #28
	bne _kkey
	jmp _dos
*
setgr0	ldx #$60
	lda #$0c
	sta iccmd,X
	jsr ciomain

	ldx #$60
	lda #$03
	sta iccmd,X
	lda #<dev
	sta icbufa,X
	lda #>dev
	sta icbufa+1,x
	lda #44
	sta icax1,x
	lda #0
	sta icax2,x
	jmp ciomain

colpal3	dta $38,$cb,$46,$fe
dev	dta 83,58,155

	org $4498
telogo	ins "theend.dat"
